module TreasureHunt
  require_relative 'player'

  class ClumsyPlayer < Player
    attr_reader :boost
    
    def initialize(name, health=100, boost=1)
      super(name, health)
      @boost = boost
    end
    
    def heal
      @boost.times { super }
    end
    
    def found_treasure(treasure)
      super((Treasure.new(treasure.name, treasure.points / Integer(2.0))))
    end

  end

  if __FILE__ == $0
    sms_boy = ClumsyPlayer.new('sms boy')  
    
    guitar = Treasure.new(:guitar, 50)
    sms_boy.found_treasure(guitar)
    sms_boy.found_treasure(guitar)
    sms_boy.found_treasure(guitar)
    
    ruby = Treasure.new(:ruby, 400)
    sms_boy.found_treasure(ruby)
    
    sms_boy.each_found_treasure do |treasure|
      puts "#{treasure.points} total #{treasure.name} points"
    end
    puts "#{sms_boy.points} grand total points"
  end
end